/**
 * File: merge-lists.cpp
 * ---------------------
 * Here's a short program that implements and exercises 
 * a mergeLists routine, which destructively unifies 
 * two sorted lists into one sorted list (retaining any 
 * duplicates that may be present).
 */

#include <iostream>
#include "console.h"
#include "simpio.h"
#include "set.h"
#include "random.h"
using namespace std;

struct node {
	int value;
	node *next;
};

static node *mergeLists(node *one, node *two) {
	// replace what follows with your own implementation
	return NULL;
}

static int getIntegerInRange(string prompt, int low = 1, int high = 1000) {
	while (true) {
		int response = getInteger(prompt);
		if (response >= low && response <= high) return response;
		cout << "Please enter something between " << low << " and " << high << ", inclusive." << endl;
	}
}

static node *generateRandomSortedList(int listlength, int low = 1, int high = 1000) {
	Set<int> numbers;
	while (numbers.size() < listlength) {
		int number = randomInteger(low, high);
		numbers += number;
	}
	
	node *list = NULL;
    node **currp = &list;
	foreach (int number in numbers) {
		node *tail = new node;
		tail->value = number;
		tail->next = NULL;
		*currp = tail;
        currp = &(tail->next);
	}
	
	return list;
}

static void analyzeList(string preamble, node *list) {
	int length = 0;
	bool ellipsisPrinted = false;
	cout << preamble << ": [";
	node *curr = list;
	while (curr != NULL) {
		if (length < 3 || curr->next == NULL ||
            curr->next->next == NULL || curr->next->next->next == NULL) {
			cout << curr->value;
			if (curr->next != NULL) cout << ", ";
		} else if (!ellipsisPrinted){
			cout << "..., ";
			ellipsisPrinted = true;
		}
		length++;
		curr = curr->next;
	}
	cout << "] (length: " << length << ")" << endl;
}

static void disposeList(node *list) {
	node *curr = list;
	while (curr != NULL) {
		node *next = curr->next;
		delete curr;
		curr = next;
	}
}

int main() {
	while (true) {
		int sizeone = getIntegerInRange("Please enter the size of the first list (0 to quit): ", 0);
		if (sizeone == 0) break;
		node *one = generateRandomSortedList(sizeone);
		analyzeList("List 1", one);
		int sizetwo = getIntegerInRange("Please enter the size of the second list: ");
		node *two = generateRandomSortedList(sizetwo);
		analyzeList("List 2", two);
		cout << "Merging two lists into one." << endl;
		node *merged = mergeLists(one, two);
		analyzeList("Merged List", merged);
		disposeList(merged);
		cout << endl;
	}

	return 0;
}
